<?php
#BEGIN_LICENSE
#-------------------------------------------------------------------------
# Module: MAMS (c) 2020-2021 by CMS Made Simple Foundation
#  An add-on module for CMS Made Simple to provide useful functions
#  and commonly used gui capabilities to other modules.
#-------------------------------------------------------------------------
# A fork of:
#
# Module: FrontEndUsers (c) 2008-2014 by Robert Campbell
#         (calguy1000@cmsmadesimple.org)
#
#-------------------------------------------------------------------------
#
# CMSMS - CMS Made Simple is (c) 2006 - 2021 by CMS Made Simple Foundation
# CMSMS - CMS Made Simple is (c) 2005 by Ted Kulp (wishy@cmsmadesimple.org)
# Visit the CMSMS Homepage at: http://www.cmsmadesimple.org
#
#-------------------------------------------------------------------------
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# However, as a special exception to the GPL, this software is distributed
# as an addon module to CMS Made Simple.  You may not use this software
# in any Non GPL version of CMS Made simple, or in any version of CMS
# Made simple that does not indicate clearly and obviously in its admin
# section that the site was built with CMS Made simple.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
# Or read it online: http://www.gnu.org/licenses/licenses.html#GPL
#
#-------------------------------------------------------------------------
#END_LICENSE

namespace MAMS\Commands;
use CMSMS\CLI\App;
use CMSMS\CLI\GetOptExt\Command;
use CMSMS\CLI\GetOptExt\Option;
use CMSMS\CLI\GetOptExt\GetOpt;
use GetOpt\Operand;
use mams_user_query;
use mams_user_query_opt;

class GroupEditCommand extends Command
{
    public function __construct( App $app )
    {
        parent::__construct( $app, 'mams-group-edit' );
        $this->addOperand( new Operand( 'group', Operand::REQUIRED ) );
        $this->addOption( Option::Create(null,'rename', GetOpt::REQUIRED_ARGUMENT)->setDescription('Adjust the group name'));
        $this->addOption( Option::Create(null,'description', GetOpt::REQUIRED_ARGUMENT)->setDescription('Adjust the group description'));
        // mams-group-edit users newdesc --rename foobar --description stuff
    }

    public function getShortDescription()
    {
        return 'Edit an FEU Group definition';
    }

    public function getLongDescription()
    {
        return 'Edit an FEU Group definition';
    }

    public function handle()
    {
        $group = trim($this->getOperand('group')->value());
        $newname = trim($this->getOption('rename')->value());
        $newdesc = trim($this->getOption('description')->value());

        $gid = $mams->GetGroupID( $group );
        if( $gid < 1 ) throw new \RuntimeException("Group $group not found");
        $desc = $mams->GetGroupDesc( $gid );

        if( !$newname || !$newdesc ) throw new \RuntimeException('Please specify at least one of the rename or description options');
        if( $newname ) {
            // validate the group name
            if( !preg_match('#[a-z0-9][_\-a-z0-9]*#i', $newname) ) throw new \RuntimeException("Invalid group name $newname");
            // validate that this new name is not used
            $new_gid = $mams->GetGroupID( $newname );
            if( $new_gid > 0 ) throw new \RuntimeException("Group name $newname already exists");
        }

        // get the group info
        if( $newname ) $group = $newname;
        if( $newdesc ) $desc  = $newdesc;

        $mams->SetGroup( $gid, $group, $desc );
    }
} // end of class.
